#include "glKeyboard.h"

// TODO: I need to consider somethings
// Some times, I want so see if a comb of keys was pressed (shift+F1)
// Others, I dont want that ctrl or shift to be considered (shift+UP)
// If think this is a app to app decision, but I would like to carry both situations
// Defines to set situations???

// DONE: Simplest situation: Key is pressed right now or not.
// No modifiers take in count
// IDEIAS: Use timer to get modifiers
// Creat list of keys treated in other ways. Maybe call functions

// Internal Variables
bool *activeKeys=NULL;

void (*userKeyboardNotify)(int key, bool release)=NULL;

// Internal functions headers
void glKeyboardKeyPressed(unsigned char key, int x, int y);
void glKeyboardKeyReleased(unsigned char key, int x, int y);
void glKeyboardSpecialPressed(int key, int x, int y);
void glKeyboardSpecialReleased(int key, int x, int y);


// ************************************************************************
// Function

// Install keyboard functions
void glKeyboardInstall(void)
{
    int c;
    // We will manage repetion status
    glutIgnoreKeyRepeat(1);

    // set callback functions
    glutKeyboardFunc(glKeyboardKeyPressed);
    glutKeyboardUpFunc(glKeyboardKeyReleased);
    glutSpecialFunc(glKeyboardSpecialPressed);
    glutSpecialUpFunc(glKeyboardSpecialReleased);

    activeKeys=new bool[maxKeys];
    for (c=0;c<maxKeys;c++)
    {
        activeKeys[c]=false;
    }
}

// Set the function pointer to be called at display redraw
void setUserKeyboardNotify(void (*notify)(int key, bool release))
{
    // update pointer
    userKeyboardNotify=notify;
}

bool keyIsPressed(int key)
{
    return activeKeys[key];
}

// ***********************************************************************
// Internal Functions
// Used to transparency management of screens

void glKeyboardKeyPressed(unsigned char key, int x, int y)
{
    activeKeys[key]=true;
    // Call user notify function, if any
    if (userKeyboardNotify!=NULL)
        userKeyboardNotify(key,false);
}

void glKeyboardKeyReleased(unsigned char key, int x, int y)
{
    activeKeys[key]=false;
    // Call user notify function, if any
    if (userKeyboardNotify!=NULL)
        userKeyboardNotify(key,true);
}

void glKeyboardSpecialPressed(int key, int x, int y)
{
    activeKeys[key+256]=true;
    // Call user notify function, if any
    if (userKeyboardNotify!=NULL)
        userKeyboardNotify(key+256, false);
}

void glKeyboardSpecialReleased(int key, int x, int y)
{
    activeKeys[key+256]=false;
    // Call user notify function, if any
    if (userKeyboardNotify!=NULL)
        userKeyboardNotify(key+256, true);
}
