#include "glMouse.h"

// Internal Var
bool buttons[3]={false,false,false};
int mouseX=-1, mouseY=-1;
bool onScreen=false;

void (*userMouseNotify)(int action)=NULL;


// Internal functions headers
void glMouseButton(int button, int state, int x, int y);
void glMouseMove(int x,int y);
void glMouseEntry(int state);

// ************************************************************************
// Function

// Install Mouse functions
void glMouseInstall(void)
{
    glutMouseFunc(glMouseButton);
    glutMotionFunc(glMouseMove);
    glutPassiveMotionFunc(glMouseMove);
    glutEntryFunc(glMouseEntry);
}

// Set notify Functions
void setUserMouseNotify(void (*notify)(int action))
{
    userMouseNotify=notify;
}

bool mouseIsPressed(int button)
{
    if ((unsigned)button<3)
        return buttons[button];
    else
        return false;
}

void mousePosition(int *x, int *y)
{
    *x=mouseX;
    *y=mouseY;
}

bool mouseOnScreen(void)
{
    return onScreen;
}

// ************************************************************************
// Internal functions headers
void glMouseButton(int button, int state, int x, int y)
{
    buttons[button]=(state==GLUT_DOWN ? true : false);
    mouseX=x;
    mouseY=y;
    if (userMouseNotify!=NULL)
        userMouseNotify((state==GLUT_DOWN ? MOUSE_BUTTON_PRESSED : MOUSE_BUTTON_RELEASED ));
}

void glMouseMove(int x,int y)
{
    mouseX=x;
    mouseY=y;
    if (userMouseNotify!=NULL)
        userMouseNotify(MOUSE_MOVED);

}

void glMouseEntry(int state)
{
    onScreen=(state==GLUT_ENTERED ? true : false);
    if (userMouseNotify!=NULL)
        userMouseNotify(MOUSE_MOVED);

}
