#include "glSprite.h"

glSprite::glSprite(void)
{
    tex=NULL;
    sizeX=sizeY=elemX=elemY=-1;
}

glSprite::~glSprite(void)
{
    if (tex)
        delete tex;
}

void glSprite::loadImage(char *filename, int sX, int sY, int eX, int eY)
{
    Image *img=new Image(true);
    if (img->loadRGBA(filename)==false)
        printf("[glSprite::loadImage] Error: Could not read file %s\n",filename);
    setImage(img,sX,sY,eX,eY);
}

void glSprite::setImage(Image *img, int sX, int sY, int eX, int eY)
{
    width=img->getTextureWidth();
    height=img->getTextureHeight();

    image=img;
    tex=new glTexture();
    tex->setTexture(img);
    tex->setTransparent(true);

    sizeX=sX;
    sizeY=sY;
    elemX=eX;
    elemY=eY;
}

Image *glSprite::getUnitImage(int eX, int eY)
{
    return image->copyImage(sizeX*eX,sizeY*eY,sizeX,sizeY);
}

void glSprite::getUnitSize(int *width, int *height)
{
    *width=sizeX;
    *height=sizeY;
}

void glSprite::draw(int x, int y, int eX, int eY)
{
    float sX,sY;

    sX=(float)sizeX/(float)width;
    sY=(float)sizeY/(float)height;

    tex->bindTexture();
    glBegin(GL_QUADS);
        glTexCoord2d(sX*eX    ,sY*eY);
        glVertex2i(x      ,y);
        glTexCoord2d(sX*(eX+1),sY*eY);
        glVertex2i(x+sizeX,y);
        glTexCoord2d(sX*(eX+1),sY*(eY+1));
        glVertex2i(x+sizeX,y+sizeY);
        glTexCoord2d(sX*eX    ,sY*(eY+1));
        glVertex2i(x      ,y+sizeY);
    glEnd();
    tex->unbindTexture();
}
