#ifndef __glSprite_h__
#define __glSprite_h__

#include "glTexture.h"

// Manage a sprite with multiple drawings
class glSprite
{
    protected:
        Image *image;
        glTexture *tex;
        int width,height;
        int sizeX, sizeY; // Size of 1 unit of the texture
        int elemX, elemY; // Number of units in X and Y

    public:
        glSprite(void);
        virtual ~glSprite(void);

        void loadImage(char *filename, int sX, int sY, int eX, int eY);
        void setImage(Image *img, int sX, int sY, int eX, int eY);

        Image *getUnitImage(int eX, int eY);
        void getUnitSize(int *width, int *height);

        virtual void draw(int x, int y, int eX=0, int eY=0);

};

#endif
