#ifndef __board_h__
#define __board_h__

#include "../general.h"
#include "../base.h"
#include "../Net/net.h"
#include "../Net/xmlParser.h"

#include "pieceDraw.h"


typedef struct _PieceOnBoard
{
    bool empty;
    unsigned short player;
    unsigned short piece;
    unsigned short orientation;
} PieceOnBoard;

#define RotateClockWise 0
#define RotateAntiClockWise 1

class Board
{
    protected:
        int gameId,playerId,playerNumber;
        PieceOnBoard pieces[10][8];
        PieceOnBoard piecesNew[10][8];
        XMLParser *laser;

        int turnPlayer;

    public:
        Board(void);
        ~Board(void);

        void setGameId(int gameId);
        void setPlayerId(int playerId);
        void setPlayerNumber(int playerNumber);
        int getGameId(void);
        int getPlayerId(void);
        int getPlayerNumber(void);

        int getTurnPlayer(void);

        void askServer(bool update);
        void updateBoard(void);

        bool doMove(int i1,int j1, int i2, int j2);
        bool doRotate(int i1,int j1, int sense);

        PieceOnBoard getPiece(int i, int j,bool old=true);

        char *getLaser(void);
        PieceOnBoard getDestroyedPiece(int *i, int *j);

        int piecesOnBoard(int Player,bool old=true);

        PieceOnBoard translatePiece(char *pieceText);

};

#endif
