#include "boardDraw.h"

BoardDraw::BoardDraw(int startX, int startY)
{
    this->startX=startX;
    this->startY=startY;
}


int BoardDraw::getXOf(int i, int j)
{
    return startX + BoardTileSize*(i+1);
}

int BoardDraw::getYOf(int i, int j)
{
    return startY + BoardTileSize*(j+1);
}

int BoardDraw::getIOf(int x, int y)
{
    return (x-startX)/BoardTileSize-1;
}

int BoardDraw::getJOf(int x, int y)
{
    return (y-startY)/BoardTileSize-1;
}


void BoardDraw::draw(void)
{
    void *font=GLUT_BITMAP_TIMES_ROMAN_24;
    char buffer[2]="0";
    int i,j;
    unsigned short tile;
    for (i=-1;i<11;i++)
        for (j=-1;j<9;j++)
        {
            if (i>=0 && i<=9 && j>=0 && j<=7)
            {
                switch(i)
                {
                    case BoardGoldenColumn:
                        tile = BoardTileGolden;
                        break;
                    case BoardSilverColumn:
                        tile = BoardTileSilver;
                        break;
                    default:
                        tile = BoardTileNormal;
                }
            }
            else
                tile = BoardTileBorder;

            BoardTileDraw::draw(getXOf(i,j),getYOf(i,j),tile);

            if (i==-1 && j>=0 && j<=7)
            {
                buffer[0]='A'+j;
                glColor3f(1,1,1);
                glTextString(getXOf(i,j)+32,getYOf(i,j)+44,0,font,buffer);
            }

            if (j==-1 && i>=0 && i<=9)
            {
                buffer[0]='0'+i;
                glColor3f(1,1,1);
                glTextString(getXOf(i,j)+32-8,getYOf(i,j)+44,0,font,buffer);
            }
        }
    // Draw lasers
    int x,y;
    x=getXOf(0,0);
    y=getYOf(0,0);
    glColor3f(.7,0,0);
    glBegin(GL_QUADS);
        glVertex3f(x+25,y+1,0);
        glVertex3f(x+28,y+7,0);
        glVertex3f(x+35,y+7,0);
        glVertex3f(x+38,y+1,0);
    glEnd();

    x=getXOf(9,7);
    y=getYOf(9,7);
    glColor3f(.7,0,0);
    glBegin(GL_QUADS);
        glVertex3f(x+25,y+64-1,0);
        glVertex3f(x+28,y+64-7,0);
        glVertex3f(x+35,y+64-7,0);
        glVertex3f(x+38,y+64-1,0);
    glEnd();
}
