#ifndef __gameScreen_h__
#define __gameScreen_h__

#include "../base.h"
#include "../mainLoop.h"
#include "../GL/glInterface.h"
#include "../GL/glTexture.h"
#include "../GL/glText.h"
#include "../GL/glInit.h"

#include "../Net/net.h"
#include "../Net/xmlParser.h"

#include "pieceDraw.h"
#include "boardDraw.h"
#include "board.h"

class GlIGameScreen : public GLInterface
{
    protected:
        int game, playerId,playerNumber;

        Board *board;
        BoardDraw *boardDraw;

        int selected;
        bool animate;

    public:
        GlIGameScreen(void);
        virtual ~GlIGameScreen(void);

        virtual void display(void);
        virtual void reshape(int width, int height);
        virtual void keyboard(int key, bool release);
        virtual void timer(void);
        virtual void mouse(int action);

        virtual void setGame(int game);
        virtual void setPlayerId(int playerId);
        virtual void setPlayerNumber(int playerNumber);

        virtual void chooseMousePointer(void);

        virtual void drawLaser(char *laser, int step);
};


#endif
