#ifndef __image_h__
#define __image_h__

#include "../general.h"

typedef struct _ColorRGBA
{
    unsigned char red, green, blue, alpha;
} ColorRGBA;

// Defines
class Image
{
    private:
        bool isTexture;
        ColorRGBA *img;
        int texWidth,texHeight;
        int realWidth,realHeight;

    public:
        Image(bool texture);
        Image(int width, int height);
        ~Image(void);

        Image *copyImage(int x, int y, int w, int h);
        Image *duplicate(void);
        void clearRegion(int x, int y, int width, int height);

        ColorRGBA *getPointer(void);
        int getWidth(void);
        int getHeight(void);

        int getTextureWidth(void);
        int getTextureHeight(void);

        ColorRGBA getPixel(int x, int y);
        void setPixel(int x, int y, ColorRGBA color);

        bool create(int width, int height, ColorRGBA background);
        bool loadPPM(char *filename);
        bool loadRGBA(char *filename);

        void blit(int dx,int dy, Image *source, int sx, int sy, int sw, int sh);
        int alphaCollision(int dx,int dy, Image *source, int sx, int sy, int sw, int sh, int alphaMinimum=64);
};



#endif
