#include "net.h"

struct sockaddr_in remoteServAddr;
struct sockaddr_in cliAddr;


Net::Net()
{
    answer[0]='\0';
}

int Net::clientConnect(void)
{
    int sock,rc;

    sock = socket(AF_INET,SOCK_DGRAM,0);
    if(sock<0)
    {
        printf("[Net::clientConnect] Unable to create socket\n");
        return sock;
    }

    /* bind any port */
    cliAddr.sin_family = AF_INET;
    cliAddr.sin_addr.s_addr = htonl(INADDR_ANY);
    cliAddr.sin_port = htons(0);

    rc = bind(sock, (struct sockaddr *) &cliAddr, sizeof(cliAddr));
    if(rc<0)
    {
        printf("[Net::clientConnect] Unable to bind\n");
        return -1;
    }

    return sock;
}


bool Net::receiveMessage(int sock)
{
    socklen_t cliLen=sizeof(struct sockaddr_in);

    int recvMsgSize;

    forcedBack:

    if ((recvMsgSize = recvfrom(sock, answer, 65536, 0,(struct sockaddr *)&cliAddr,&cliLen)) ==-1 && errno!=EAGAIN)
    {
        printf("[Net::receiveMessage] Error receiving answer\n");
        answer[0]='\0';
        return false;
    }

    if (recvMsgSize==-1 && errno==EAGAIN)
    {
        recvMsgSize=-2;
        answer[0]='\0';
    }

    // TODO: Correct this HACK!!!
    if (answer[0]=='\0')
        goto forcedBack;

    return true;
}

bool Net::sendRequest(char *message)
{
    int sock,rc;
    if ((sock=clientConnect())<0)
    {
        printf("[Net::sendRequest] Unable to create socket\n");
        return false;
    }

    rc = sendto(sock, message, strlen(message), 0, (struct sockaddr *) &remoteServAddr,sizeof(struct sockaddr_in));
    if (rc<0)
    {
        printf("[Net::sendRequest] Error sending message (%i)\n",rc);
        return false;
    }

    return receiveMessage(sock);
}

char *Net::getAnswer(void)
{
    return answer;
}

bool Net::setServer(char *ip, int port)
{
    struct hostent *h;

    h = gethostbyname(ip);
    if (h==NULL)
    {
        printf("[Net::setServer] Unable to find ip of '%s' \n", ip);
    }

    remoteServAddr.sin_family = h->h_addrtype;
    memcpy((char *) &remoteServAddr.sin_addr.s_addr,h->h_addr_list[0], h->h_length);
    remoteServAddr.sin_port = htons(port);

    return false;
}


