#include "xmlParser.h"

int XMLParser::compareTag(char *tag1, char *tag2)
{
    int t;
    while (*tag1!='>' && *tag2!='>')
        if ((t=(*tag1++)-(*tag2++))!=0)
            return t;
    return (*tag1)-(*tag2);
}

int XMLParser::compareCloseTag(char *tag1, char *tag2)
{
    int t;
    while (*tag1!='>' && *tag2!='>')
    {
        if (*tag1=='/')
            tag1++;
        if (*tag2=='/')
            tag2++;
        if ((t=(*tag1++)-(*tag2++))!=0)
            return t;
    }
    return (*tag1)-(*tag2);
}

XMLParser::XMLParser(char *xml, char *tag, int jump)
{
    char *xml_t=xml;
    char *last_tag;
    content=(char *)malloc(strlen(xml));
    strcpy(content,"");

    if (!content)
    {
        printf("[XMLParser::XMLParser] Not enough memory\n");
    }

    while (*xml_t && jump>=0 )
    {
        while (*xml_t && compareTag(xml_t,tag)!=0)
        {
            last_tag=xml_t;

            while (*xml && *++xml_t!='<');

            while (*xml_t && compareCloseTag(xml_t,last_tag)!=0)
            {
                while (*xml_t && *++xml_t!='<');
            }

            while (*xml_t && *++xml_t!='<');
        }

        if (*xml_t)
        {
            if (jump>0)
            {
                while (*xml_t++!='>');

                while (compareCloseTag(xml_t,tag)!=0 && *xml_t)
                    xml_t++;

                while (*xml_t && *++xml_t!='<');
            }
            else
            {
                while (*xml_t++!='>');

                strcpy(content,xml_t);
                xml_t=content;
                while (compareCloseTag(xml_t,tag)!=0 && *xml_t)
                    xml_t++;

                *xml_t='\0';
            }
        }
        jump--;


    }

}

XMLParser::~XMLParser()
{
    if (content)
        free((void *)content);
}

char *XMLParser::getContent(void)
{
    return content;
}
