#ifndef __startScreen_h__
#define __startScreen_h__

#include "../base.h"
#include "../mainLoop.h"
#include "../GL/glInterface.h"
#include "../GL/glTexture.h"
#include "../GL/glText.h"
#include "../GL/glMouse.h"
#include "../GL/glInit.h"

#include "../Net/net.h"
#include "../Net/xmlParser.h"

#include "../Game/gameScreen.h"

typedef struct _GameList
{
    int gameId;
    int numPlayers;
    bool needPlayers;
    bool ended;
} GameList;

class GlIStartScreen : public GLInterface
{
    protected:
        glTexture *texBackground;

        GlIGameScreen *gs;

        GameList gameList[256];
        int gameListSize;

        void getGameList(void);

        int mouseOption;
        bool firstDraw;

    public:
        GlIStartScreen(void);
        virtual ~GlIStartScreen(void);

        virtual void display(void);
        virtual void reshape(int width, int height);
        virtual void keyboard(int key, bool release);
        virtual void timer(void);
        virtual void mouse(int action);
};


#endif
