#include "general.h"
#include "base.h"

#include "mainLoop.h"
#include "GL/glInit.h"
#include "StartScreen/startScreen.h"

#include <time.h>


//#include <SDL/SDL.h>
//#include <SDL/SDL_mixer.h>

GLInterface *startScreenPtr;

int main(int argc, char *argv[])
{
    time_t seeder;

    seeder=time(NULL);

    srandom(seeder);

    if (argc>=2)
        ServerName=argv[1];
    if (argc>=3)
        ServerPort=atoi(argv[2]);


    printf("Usage: CDeflexion <Server> <port> to change server\n");
    printf("Server:port =  %s:%i\n",ServerName,ServerPort);


    glutInit(&argc,argv);
    CreateMainWindow("CDeflexion",64*12,64*10+64,60,20);

    baseStart();

    setMainLoop();
    setInterface(startScreenPtr=new GlIStartScreen());

    glutMainLoop ();

    return 0;
}


/*
* LIST OF GAMES:	<REQUEST><RT>LIST GAMES</RT><GT>[all|checkers|deflexion|...]</GT><GS>[all|waiting_players]</GS></REQUEST>
* NEW GAME:		<REQUEST><RT>NEW GAME</RT><GT>[checkers|deflexion|...]CHECKERS</GT>[<GAME_NAME>[string game name]</GAME_NAME>][<PLAYER>[|player1_id]</PLAYER>]</REQUEST>
* JOIN GAME:	 	<REQUEST><RT>JOIN GAME</RT><GID>[game_id]</GID><PLAYER>[player_id]</PLAYER></REQUEST>
* DELETE GAME:	<REQUEST><RT>DELETE GAME</RT><GID>[game_id]</GID></REQUEST>
* ADD PIECE: 	<REQUEST><RT>ADD PIECE</RT><GID>[game_id]</GID><PLAYER>[player_id]</PLAYER><X>[x value]</X><Y>[y value]</Y></REQUEST>
* MOVE PIECE: <REQUEST><RT>MOVE PIECE</RT><GID>[game_id]</GID><PLAYER>[player_id]</PLAYER><X>[from x1]</X><Y>[from y1]</Y><X2>[to x2]</X2><Y2>[to y2]</Y2></REQUEST>
* ROTATE PIECE:	<REQUEST><RT>ROTATE PIECE</RT><GID>[game_id]</GID><PLAYER>[player_id]</PLAYER><X>[x value]</X><Y>[y value]</Y><SENSE>[CLOCKWISE|ANTICLOCKWISE]</SENSE></REQUEST>
*/
