#include "mainLoop.h"

#include "GL/glInit.h"
#include "GL/glKeyboard.h"
#include "GL/glMouse.h"


GLInterface *interface=NULL;

void mainLoopDisplay(void);
void mainLoopReshape(int width, int height);
void mainLoopKeyboard(int key, bool release);
void mainLoopMouse(int action);
void mainLoopTimer(void);

// ************************************************************************
// Function
void setMainLoop(void)
{
    glKeyboardInstall();
    glMouseInstall();

    SetUserDisplayFunction(mainLoopDisplay);
    SetUserReshapeFunction(mainLoopReshape);
    setUserKeyboardNotify(mainLoopKeyboard);
    setUserMouseNotify(mainLoopMouse);
    SetUserTimer(1000/GameFPS,mainLoopTimer);
}

void setInterface(GLInterface *set)
{
    interface=set;
    glutPostRedisplay();
}

GLInterface *getInterface(void)
{
    return interface;
}

void mainLoopDisplay(void)
{
    if (interface)
        interface->display();
}

void mainLoopReshape(int width, int height)
{
    if (interface)
        interface->reshape(width,height);
}

void mainLoopKeyboard(int key, bool release)
{
    if (interface)
        interface->keyboard(key,release);
}

void mainLoopMouse(int action)
{
        if (interface)
            interface->mouse(action);
}

void mainLoopTimer(void)
{
    if (interface)
        interface->timer();
}
